3 # IMPORTANT: the following assumptions are made
4 # * the GH repo is on the origin remote
5 # * the gh-pages branch is named so locally
6 # * the git config user.signingkey is properly set
9 # pip install coverage nose rsa wheel
13 # make hash on local files
19 buildserver
='localhost:8142'
28 --gpg-sign-commits|-S)
37 echo "ERROR: unknown option $1"
46 if [ -z "$1" ]; then echo "ERROR: specify version number like this: $0 1994.09.06"; exit 1; fi
48 major_version
=$(echo "$version" | sed -n 's#^\([0-9]*\.[0-9]*\.[0-9]*\).
*#\1#p')
49 if test "$major_version" '!=' "$(date '+%Y.%m.%d')"; then
50 echo "$version does not start with today's date!"
54 if [ ! -z "`git tag | grep "$version"`" ]; then echo 'ERROR: version already present'; exit 1; fi
55 if [ ! -z "`git status --porcelain | grep -v CHANGELOG`" ]; then echo 'ERROR: the working directory is not clean; commit or stash changes'; exit 1; fi
56 useless_files
=$(find youtube_dl -type f -not -name '*.py')
57 if [ ! -z "$useless_files" ]; then echo "ERROR: Non-.py files in youtube_dl: $useless_files"; exit 1; fi
58 if [ ! -f "updates_key.pem" ]; then echo 'ERROR: updates_key.pem missing'; exit 1; fi
59 if ! type pandoc
>/dev
/null
2>/dev
/null
; then echo 'ERROR: pandoc is missing'; exit 1; fi
60 if ! python3
-c 'import rsa' 2>/dev
/null
; then echo 'ERROR: python3-rsa is missing'; exit 1; fi
61 if ! python3
-c 'import wheel' 2>/dev
/null
; then echo 'ERROR: wheel is missing'; exit 1; fi
63 read -p "Is ChangeLog up to date? (y/n) " -n 1
64 if [[ ! $REPLY =~ ^
[Yy
]$
]]; then exit 1; fi
66 /bin
/echo -e "\n### First of all, testing..."
71 nosetests
--verbose --with-coverage --cover-package=youtube_dl
--cover-html test --stop || exit 1
74 /bin
/echo -e "\n### Changing version in version.py..."
75 sed -i "s/__version__ = '.*'/__version__ = '$version'/" youtube_dl
/version.py
77 /bin
/echo -e "\n### Changing version in ChangeLog..."
78 sed -i "s/<unreleased>/$version/" ChangeLog
80 /bin
/echo -e "\n### Committing documentation, templates and youtube_dl/version.py..."
81 make README.md CONTRIBUTING.md .github
/ISSUE_TEMPLATE.md supportedsites
82 git add README.md CONTRIBUTING.md .github
/ISSUE_TEMPLATE.md docs
/supportedsites.md youtube_dl
/version.py ChangeLog
83 git commit
$gpg_sign_commits -m "release $version"
85 /bin
/echo -e "\n### Now tagging, signing and pushing..."
86 git tag
-s -m "Release $version" "$version"
88 read -p "Is it good, can I push? (y/n) " -n 1
89 if [[ ! $REPLY =~ ^
[Yy
]$
]]; then exit 1; fi
91 MASTER
=$(git rev-parse --abbrev-ref HEAD)
92 git push origin
$MASTER:master
93 git push origin
"$version"
95 /bin
/echo -e "\n### OK, now it is time to build the binaries..."
96 REV
=$(git rev-parse HEAD)
97 make youtube
-dl youtube
-dl.
tar.gz
98 read -p "VM running? (y/n) " -n 1
99 wget
"http://$buildserver/build/rg3/youtube-dl/youtube-dl.exe?rev=$REV" -O youtube
-dl.exe
100 mkdir -p "build/$version"
101 mv youtube
-dl youtube
-dl.exe
"build/$version"
102 mv youtube
-dl.
tar.gz
"build/$version/youtube-dl-$version.tar.gz"
103 RELEASE_FILES
="youtube-dl youtube-dl.exe youtube-dl-$version.tar.gz"
104 (cd build
/$version/ && md5sum $RELEASE_FILES > MD5SUMS
)
105 (cd build
/$version/ && sha1sum $RELEASE_FILES > SHA1SUMS
)
106 (cd build
/$version/ && sha256sum
$RELEASE_FILES > SHA2
-256SUMS)
107 (cd build
/$version/ && sha512sum
$RELEASE_FILES > SHA2
-512SUMS)
109 /bin
/echo -e "\n### Signing and uploading the new binaries to GitHub..."
110 for f
in $RELEASE_FILES; do gpg
--passphrase-repeat 5 --detach-sig "build/$version/$f"; done
113 python devscripts
/create
-github-release.py ChangeLog
$version "$ROOT/build/$version"
115 ssh ytdl@yt
-dl.org
"sh html/update_latest.sh $version"
117 /bin
/echo -e "\n### Now switching to gh-pages..."
118 git clone
--branch gh
-pages --single-branch . build
/gh
-pages
121 ORIGIN_URL
=$(git config --get remote.origin.url)
123 "$ROOT/devscripts/gh-pages/add-version.py" $version
124 "$ROOT/devscripts/gh-pages/update-feed.py"
125 "$ROOT/devscripts/gh-pages/sign-versions.py" < "$ROOT/updates_key.pem"
126 "$ROOT/devscripts/gh-pages/generate-download.py"
127 "$ROOT/devscripts/gh-pages/update-copyright.py"
128 "$ROOT/devscripts/gh-pages/update-sites.py"
129 git add
*.html
*.html.
in update
130 git commit
$gpg_sign_commits -m "release $version"
131 git push
"$ROOT" gh
-pages
132 git push
"$ORIGIN_URL" gh
-pages
137 echo "Uploading to PyPi ..."
138 python setup.py sdist bdist_wheel upload
141 /bin
/echo -e "\n### DONE!"